<template>
		<el-dialog
			width="30%"
			title="Add New Permission"
			:visible="dialogFormvisible"
			append-to-body
			@close="closeDialog('content')">
			<el-form id="add-form" :model="content" :rules="rules" ref="content" label-width="120px" class="demo-content-account" v-loading="loading" @keyup.enter.native="submitForm('content')"
            >
                <el-form-item class="" prop="url" label="URL" >
					<el-input ref="url" @keyup.enter.native="loseFocus('url')" type="text" placeholder="Enter permission URL" v-model="content.url"></el-input>
				</el-form-item>
                <el-form-item ref="verb" @keyup.enter.native="loseFocus('verb')" class="" prop="verb" label="Method" >
					<el-select v-model="content.verb" placeholder="Select method" label="Verb" class="width100">
                        <el-option
                        v-for="item in content.verbOptions"
                        :key="item"
                        :value="item">
                        </el-option>
                    </el-select>
				</el-form-item>

                <el-form-item class="" prop="display_name" label="Display Name" >
					<el-input ref="display_name" @keyup.enter.native="loseFocus('display_name')" type="text" placeholder="Enter permission name" v-model="content.display_name"></el-input>
				</el-form-item>
				<el-form-item class="" prop="description" label="Description" >
					<el-input type="text" placeholder="Enter description"  v-model="content.description"></el-input>
				</el-form-item>

				<div style="text-align: right; margin-top: 30px;">
					<el-button type="primary" @click="submitForm('content')" :disabled="loading" icon="mdi mdi-plus">Add</el-button>
				</div>
			</el-form>
		</el-dialog>
</template>

<script>
    import $ from 'jquery'
    import {permission as permissionAPI} from '~/services/apis/index';
    export default {
		name: 'AddPermision',
		props: [ 'dialogFormvisible'],

		data() {
            let validateURL = (rule, value, callback) => {
                var re = /^(ftp|http|https):\/\/(([a-zA-Z0-9$\-_.+!*'(),;:&=]|%[0-9a-fA-F]{2})+@)?(((25[0-5]|2[0-4][0-9]|[0-1][0-9][0-9]|[1-9][0-9]|[0-9])(\.(25[0-5]|2[0-4][0-9]|[0-1][0-9][0-9]|[1-9][0-9]|[0-9])){3})|localhost|([a-zA-Z0-9\-\u00C0-\u017F]+\.)+([a-zA-Z]{2,}))(:[0-9]+)?(\/(([a-zA-Z0-9$\-_.+!*'(),;:@&=]|%[0-9a-fA-F]{2})*(\/([a-zA-Z0-9$\-_.+!*'(),;:@&=]|%[0-9a-fA-F]{2})*)*)?(\?([a-zA-Z0-9$\-_.+!*'(),;:@&=\/?]|%[0-9a-fA-F]{2})*)?(\#([a-zA-Z0-9$\-_.+!*'(),;:@&=\/?]|%[0-9a-fA-F]{2})*)?)?$/;
                if (re.test(value)) {
                    callback();
                } else {
                    callback(new Error('Invalid URL'));
                }
            };
			return {
                content: {
                    url: '',
                    verb: '',
                    verbOptions: ['POST', 'GET', 'DELETE', 'PUT', 'PATCH', 'OPTION'],
                    display_name:'',
                    description: null
                },
                rules: {
                    display_name: [
                        { required: true, message: 'Please input permission name', trigger: 'blur' },
                        { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
                    ],
                    url: [
                        { required: true, validator: validateURL,  message: 'Please input valid url', trigger: 'blur' },
                        { max: 255, message: 'Length must be less than 256', trigger: 'blur' },
                    ],
                    verb: [
                            {required: true, message: 'Please choose permission methods', trigger: 'blur' }
                        ]
                },
                loading: false
			}
		},
		methods: {
            submitForm(formName) {
                if(!this.$refs[formName]) return false;
                this.$refs[formName].validate((valid) => {
                    if (valid) {
                        this.loading = true;
						this.submit();
                    } else {
                        this.loading = false;
                        return false;
                    }
                });
            },
            loseFocus(inputName) {
                this.$refs[inputName].blur();
            },
            closeDialog(formName) {
                if(!this.$refs[formName]) return;
                this.$refs[formName].resetFields();
                this.$emit('update:dialogFormvisible', false);
            },
			submit() {
                let data = {
                        url: this.content.url,
                        verb: this.content.verb,
                        display_name: this.content.display_name,
                        description: this.content.description
                };

                permissionAPI.addPermission(data)
                    .then((res)=>{
                        this.$notify({
                            title: "Success",
                            message: "Add new permission successfully!",
                            type: "success"
                        });
                        this.loading = false;
                        this.closeDialog('content');
                        this.$parent.getListData();
                    })
                    .catch((err)=>{
                        this.$notify({
                            title: "Error",
                            message: "Add failed!",
                            type: "error"
                        });
                        this.loading = false;
                    })
            }

		},
		mounted(){
		var that = this;
        $('body').on("submit", "#add-form", function(e){
            event.preventDefault();
            that.submitForm('content');
        });
		}
	}
</script>

<style>
    .width100 {
        width: 100%;
    }
</style>

